local addon  = KiwiPlates
local widget = addon:newWidget( 'Plate', { 'mouseover' , 'target' } )

local next = next
local UIParent = UIParent

local function Create(kPlate)
	local db      = kPlate.db.Plate
	local width   = db.width or 150
	local height  = db.height or 20
	kPlate.width  = width
	kPlate.height = height
	kPlate:SetSize( width, height )
	kPlate:SetFrameStrata('BACKGROUND')
	kPlate:SetScale(addon.uiScale)
	if db.Textures then
		for key,db in next, db.Textures do
			addon.CreatePlateTexture(kPlate, kPlate, key, db)
		end
	end
end

local function Show(kPlate,bPlate)
	local db = kPlate.db.Plate
	kPlate:SetPoint( 'CENTER', kPlate.bPlate, 'CENTER', db.left or 0, db.top or 0)		
	kPlate:Show()
end

function widget:GetColorReceivers(skin, receivers)
	local receivers = receivers or {}
	for key,db in next, skin.Plate.Textures or {} do
		receivers[key] = db.acceptColors and key or nil
	end
	return receivers
end

function widget:OnEnable(addon)
	addon.RegisterNotify( 'PlateCreate', Create, true )
	addon.RegisterNotify( 'PlateShow', Show, true )	
end

function widget:OnDisable(addon)
	addon.UnregisterNotify( 'PlateCreate', Create )
	addon.UnregisterNotify( 'PlateShow', Show )		
end
