
local addon   = KiwiPlates
local Options = KiwiPlatesOptions

local options = {}

local function GetThemes(info)
	local t = {}
	if not strfind(info[#info],'default') then
		t['@default'] = '|cFFC0C0C0-Default-|r'
	end
	for k,v in next, addon.themes do
		t[k] = k
	end
	return t
end

local function GetThemeName(name)
	if name then
		return addon.themes[name] and name or 'Basic'
	else
		return '@default'
	end
end

local function MakeInstanceOptions(db, name, order)
options['default'..order] = {
	type = "select",
	order = order,
	width = 'normal',
	name = name..' Theme',
	desc = "",
	values = GetThemes,
	get = function() return GetThemeName(db.default) end,
	set = function(info,value) 
		db.default = value 
		addon:ThemeUpdate()
	end,
}
options['instance'..order] = {
	type = "select",
	order = order+10,
	width = 'normal',				
	name = name..' Theme',
	desc = "",
	values = GetThemes,
	get = function() return GetThemeName(db.instance) end,
	set = function(info,value) 
		db.instance = value~='@default' and value or nil 
		addon:ThemeUpdate()
	end,
}
options['pvp'..order] = {
	type = "select",
	order = order+20,
	width = 'normal',				
	name = name..' Theme',
	desc = "",
	values = GetThemes,
	get = function() return GetThemeName(db.pvp) end,
	set = function(info,value) 
		db.pvp = value~='@default' and value or nil 
		addon:ThemeUpdate()
	end,
}
options['arena'..order] = {
	type = "select",
	order = order+30,
	width = 'normal',
	name = name..' Theme',
	desc = "",
	values = GetThemes,
	get = function() return GetThemeName(db.arena) end,
	set = function(info,value) 
		db.arena = value~='@default' and value or nil
		addon:ThemeUpdate()
	end,
}
end

options.header1 = { type = 'header', order= 0, name = 'Default Themes by Role' }
options.header2 = { type = 'header', order= 9, name = 'PVE Instances Themes' }
options.header3 = { type = 'header', order=19, name = 'Battlegrounds Themes' }
options.header4 = { type = 'header', order=29, name = 'Arenas Themes' }

MakeInstanceOptions(addon.db.general.themes.DAMAGER, 'DPS',1)
MakeInstanceOptions(addon.db.general.themes.HEALER,  'HEALER', 2)	
MakeInstanceOptions(addon.db.general.themes.TANK,    'TANK',   3)

Options:RegisterCategoryOptions( 'General', options, { order = 10 } )
